{$R-,S-,I-,D+,F-,V-,B-}
{$IFNDEF FPC}
{$N-,L+}
{$ENDIF}
{$M 4096,0,0 }
{ converts *.com files to *.exe }
program comtoexe;

uses CmdLine,FreeWare;

const
	buffsize=32768;
	stubcode: array[0..7] of byte = ( $31, $F6, $56, $BE, $00, $01, $FF, $E6 );

{ The machine code was assembled this way:

-a
2976:0100 xor si, si
          31F6
2976:0102 push si
          56
2976:0103 mov si,100
          BE0001
2976:0106 jmp si
          FFE6
2976:0108
-d 100 l 8
2976:0100  31 F6 56 BE 00 01 FF E6-                        1.V.....
-

}

var nomin,nomout:string[80];
	a:byte;
	ficin,ficout:file;
	buff:array[1..buffsize] of byte;
	len:word;
	exesize,comsize:longint;
	buff1:array[1..2] of char;
	Header:array[0..15] of word;

procedure help;
begin
	Writeln('Syntax: COMTOEXE comfile[.COM] [exefile[.EXE]]');
	Writeln;
	Coordonnees;
	halt(0);
end;

procedure Fatal(s:string);
begin
	Writeln;
	writeln;
	writeln('COMTOEXE: Fatal Error: '+s);
	Writeln;
	halt(255);
end;

procedure IOtest;
var e:integer;
begin
	e:=IOresult;
	if e<>0 then Fatal(ErrorMsg(e));
end;


begin
{$IFDEF FPC}
	LFNSupport := False;
{$ENDIF}
	Writeln('COMTOEXE.EXE  (C) 1989 Fabrice Bellard, ecm release 2');
	Writeln('Converts COM files to EXE, for use with LZEXE for instance.');
	writeln;
	nomin:=GetUpCase;
	nomout:=GetUpCase;
	if nomin='' then help;
	a:=pos('.',nomin);
	if nomout='' then begin
		if a=0 then
			nomout:=nomin+'.'+'EXE'
		else begin
			nomout:=copy(nomin,1,a)+'EXE';
		end;
	end
	else begin
		if pos('.',nomout)=0 then nomout:=nomout+'.EXE';
	end;
	if a=0 then nomin:=nomin+'.COM';
	Writeln('Converting ',nomin,' to ',nomout);

	assign(ficin,nomin);
	reset(ficin,1);
	IOtest;
	BlockRead(ficin,buff1,2,len);
	IOtest;
	if (buff1='MZ') or (buff1='ZM') then
		Fatal('The file '+nomin+' seems to already be an EXE file');
	comsize:=FileSize(ficin);
	if comsize>($FE00-sizeof(stubcode)) then
		Fatal('The file '+nomin+' is too long');
	exesize:=comsize+32+sizeof(stubcode);

	assign(ficout,nomout);
	rewrite(ficout,1);
	IOtest;

	Header[0]:=byte('M')+byte('Z')*256;
	Header[1]:=exesize mod 512;
	Header[2]:=(exesize+511) div 512;
	Header[3]:=0;
	Header[4]:=2;
	header[5]:=$1000-((comsize + sizeof(stubcode) + 15) div 16);
	Header[6]:=$FFFF;
	Header[7]:=$FFF0; { ss = -16 }
	Header[8]:=0; { sp = 0 }
	Header[9]:=0;
	Header[10]:=$100 + comsize; { ip -> behind original image }
	Header[11]:=$FFF0; { cs = -16 }
	Header[12]:=$1C;
	Header[13]:=0;
	Header[14]:=0;
	Header[15]:=0;
	BlockWrite(ficout,Header,32);
	BlockWrite(ficout,Buff1,len);
	IOtest;
	repeat
		BlockRead(ficin,Buff,buffsize,len);
		BlockWrite(ficout,buff,len);
		IOtest;
	until len<>buffsize;
	BlockWrite(ficout,stubcode,sizeof(stubcode));
	IOtest;
	close(ficin);
	close(ficout);
	IOtest;
	Writeln('Conversion done.');
end.
