{$A+,B-,D+,F-,I-,O-,R-,S-,V+}
{$IFNDEF FPC}
{$E+,N-,L+}
{$ENDIF}
{$M 4096,0,0}
{ display information of an EXE file }
program infoexe;

uses cmdline,FreeWare;

type
	Thexw=string[4];
	ThexL=string[8];
	Tstr=string[80];

const
	HexStr:array[0..15] of char='0123456789ABCDEF';

procedure emptyline;
begin
	{ writeln; }
end;

function HexW(a:word):Thexw;
var
	s:ThexW;
	i:byte;

begin
	s[0]:=#4;
	for i:=4 downto 1 do begin
		s[i]:=HexStr[byte(a) and $F];
		a:=a shr 4;
	end;
	HexW:=s;
end;

function HexL(a:longint):ThexL;
var
	s:ThexL;
	i:byte;

begin
	s[0]:=#8;
	for i:=8 downto 1 do begin
		s[i]:=HexStr[byte(a) and $F];
		a:=a shr 4;
	end;
	HexL:=s;
end;


procedure help;
begin
	Writeln('Syntax: INFOEXE filename[.EXE]');
	Coordonnees;
	halt(0);
end;

procedure Fatal(s:Tstr);
begin
	Writeln;
	writeln;
	writeln('INFOEXE: Fatal Error: '+s);
	Writeln;
	halt(255);
end;

procedure IOtest;
var e:integer;
begin
	e:=IOresult;
	if e<>0 then Fatal(ErrorMsg(e));
end;

procedure Write3(a,b,c:Tstr);
begin
	while length(a)<35 do a:=a+' ';
	Writeln(a,b:15,c:15);
end;

procedure WriteW(s:Tstr;a:word);
var b:string[5];
begin
	str(a,b);
	Write3(s,b,HexW(a));
end;

procedure WriteL(s:Tstr;a:longint);
var b:string[10];
begin
	str(a,b);
	Write3(s,b,HexL(a));
end;

procedure WriteDD(s:Tstr;h,l:word);
begin
	Write3(s,'',HexW(h)+':'+HexW(l));
end;


var
	NomEXE:string[80];
	f:file;
	Hexe:array[0..15] of word;
	imageplusheadersize,size,headersize,imagesize,
	amountpages,imagesizepara:longint;

begin
	Writeln('INFOEXE.EXE  (C) 1989 Fabrice BELLARD, ecm release 2');
	Writeln('Information of an EXE file');
	emptyline;

	NomExe:=GetUpCase;
	if NomExe='' then help;
	if pos('.',NomExe)=0 then NomExe:=NomExe+'.EXE';

	assign(f,NomExe);
	reset(f,1);
	IOtest;
	BlockRead(f,Hexe,32);
	IOtest;
	size:=FileSize(f);
	Close(f);
	IOtest;
	if (Hexe[0]<>$5A4D) and (Hexe[0]<>$4D5A) then
	  Fatal('The file is not an EXE file');

	amountpages := longint(Hexe[2]);
	if (amountpages = 0) then
	  Fatal('Invalid EXE file, zero pages');
	imageplusheadersize:= (amountpages - 1) * 512;
	if ((Hexe[1]=0) or (Hexe[1]>512)) then
	  inc(imageplusheadersize,512)
	else
	  inc(imageplusheadersize,Hexe[1]);

	Writeln('Examining ',NomExe);
	emptyline;
	if (Hexe[1] > 512) then begin
		Writeln('Invalid last page bytes field! Got '+HexW(Hexe[1])+'h');
		emptyline;
	end;

	Write3('','Decimal','Hex');
	emptyline;

	headersize := Hexe[4] * 16;
	imagesize := imageplusheadersize - headersize;
	imagesizepara := (imagesize + 15) div 16;

	WriteL('Length on disk (bytes)',size);
	WriteL('Length of header + image (bytes)',imageplusheadersize);
	if imageplusheadersize<>size then
	  Writeln('The file seems to contain internal overlays.');
	emptyline;
	WriteL('Image size (paragraphs)',imagesizepara);
	WriteL('Image size (bytes)',imagesize);
	emptyline;
	WriteW('Minimum alloc (paragraphs)',Hexe[5]);
	WriteL('Minimum alloc (bytes)',Hexe[5] * 16);
	WriteW('Maximum alloc (paragraphs)',Hexe[6]);
	WriteL('Maximum alloc (bytes)',Hexe[6] * 16);
	emptyline;

	WriteW('Minimum alloc incl image (paras)',Hexe[5] + imagesizepara);
	WriteL('Minimum alloc incl image (bytes)',(Hexe[5] + imagesizepara) * 16);
	if (Hexe[6] = $FFFF) then begin
		Write3('Maximum alloc incl image (paras)','','unlimited');
		Write3('Maximum alloc incl image (bytes)','','unlimited');
	end else if (Hexe[6] + imagesizepara >= $FFFF) then begin
		Write3('Maximum alloc incl image (paras)','','unlimited (not FFFFh)');
		Write3('Maximum alloc incl image (bytes)','','unlimited (not FFFFh)');
	end else begin
		WriteW('Maximum alloc incl image (paras)',Hexe[6] + imagesizepara);
		WriteL('Maximum alloc incl image (bytes)',(Hexe[6] + imagesizepara) * 16);
	end;
	emptyline;
	WriteDD('SS:SP',Hexe[7],Hexe[8]);
	WriteDD('CS:IP',Hexe[11],Hexe[10]);
	emptyline;
	WriteW('Amount relocation entries',Hexe[3]);
	WriteW('Base of relocation entry table',Hexe[12]);
	WriteW('Header size (paragraphs)',Hexe[4]);
	WriteW('Header size (bytes)',Hexe[4] * 16);
	emptyline;
	WriteW('Overlay number',Hexe[13]);
	emptyline;
end.
